<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: controller_pid/pid_controller.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_80cb61180a2aa844c9344ada03916d41.html">controller_pid</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">pid_controller.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="pid__controller_8h__dep__incl.png" border="0" usemap="#controller__pid_2pid__controller_8hdep" alt=""/></div>
<map name="controller__pid_2pid__controller_8hdep" id="controller__pid_2pid__controller_8hdep">
<area shape="rect" id="node2" href="pid__controller_8c.html" title="controller_pid/pid\l_controller.c" alt="" coords="5,95,125,136"/>
<area shape="rect" id="node3" href="controller__pid_2test_8c.html" title="controller_pid/test.c" alt="" coords="149,102,285,129"/>
</map>
</div>
</div>
<p><a href="pid__controller_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structpid__t.html">pid_t</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:afaf1b99e536ac31c4217a4e5e4dc1bef"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a></td></tr>
<tr class="separator:afaf1b99e536ac31c4217a4e5e4dc1bef"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a037cec7ec9c7aadfcb9274df135f75d0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="pid__controller_8h.html#a037cec7ec9c7aadfcb9274df135f75d0">pid_init</a> (<a class="el" href="structpid__t.html">pid_t</a> *pid, float kp, float ki, float kd, float min_output_limit, float max_output_limit, float acceptable_error)</td></tr>
<tr class="separator:a037cec7ec9c7aadfcb9274df135f75d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aabd48cceaa1e175ce62c4297dd97c39e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="pid__controller_8h.html#aabd48cceaa1e175ce62c4297dd97c39e">pid_set_point</a> (<a class="el" href="structpid__t.html">pid_t</a> *pid, float set_point)</td></tr>
<tr class="separator:aabd48cceaa1e175ce62c4297dd97c39e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abff8c612af4d5c17b2f7141e7b557db2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="pid__controller_8h.html#abff8c612af4d5c17b2f7141e7b557db2">pid_process</a> (<a class="el" href="structpid__t.html">pid_t</a> *pid, float process_value, float dt)</td></tr>
<tr class="separator:abff8c612af4d5c17b2f7141e7b557db2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>PID controller.</p>
<p><a href="https://en.wikipedia.org/wiki/PID_controller">https://en.wikipedia.org/wiki/PID_controller</a> </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="afaf1b99e536ac31c4217a4e5e4dc1bef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afaf1b99e536ac31c4217a4e5e4dc1bef">&#9670;&nbsp;</a></span>PID_CONTROLLER_SPEC</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PID_CONTROLLER_SPEC</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>CONFIGURATION: Define for header only library, undefine for standalone module. </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a037cec7ec9c7aadfcb9274df135f75d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a037cec7ec9c7aadfcb9274df135f75d0">&#9670;&nbsp;</a></span>pid_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> void pid_init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpid__t.html">pid_t</a> *&#160;</td>
          <td class="paramname"><em>pid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>kp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>ki</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>kd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>min_output_limit</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max_output_limit</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>acceptable_error</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abff8c612af4d5c17b2f7141e7b557db2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abff8c612af4d5c17b2f7141e7b557db2">&#9670;&nbsp;</a></span>pid_process()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> float pid_process </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpid__t.html">pid_t</a> *&#160;</td>
          <td class="paramname"><em>pid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>process_value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>dt</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aabd48cceaa1e175ce62c4297dd97c39e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aabd48cceaa1e175ce62c4297dd97c39e">&#9670;&nbsp;</a></span>pid_set_point()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> void pid_set_point </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpid__t.html">pid_t</a> *&#160;</td>
          <td class="paramname"><em>pid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>set_point</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
